//CSE124C lab3 section4 --- Haibei Zhang
//sequence.h

#ifndef sequence_h
#define sequence_h

#include <iostream.h>

template <typename T>
class sequence
{
private:
	//size of sequence, number of items hold	
	int seqSize;			
		
	//internal representation of sequence
	T *array;				

public:
		
	//Constructor
	sequence(int size = 0);

	//Deconstructor, releases dynamic memory
	~sequence();

	//Overloads [] to access sequence items
	T& operator[] (int i);

	//Swap the value of 2 variables
	void swap(T& x, T& y);

	//Quicksort algrithm
	void quicksort(T A[], int low, int high);

	//Sort the whole sequence with Quicksort()
	void sort();

	//Output the whole sequence
	friend ostream& operator<< (ostream& ostr, sequence<T>& rhs);
};



//Constructor, initializing a sequence
template <typename T>
sequence<T>::sequence(int size):seqSize(0), array(NULL)
{
	if (size == 0)
		return;
	seqSize=size;
	array=new T[size];
	for (int i=0;i < size;i++)
		array[i] = T();
}

// destructor. deallocate the dynamic array
template <typename T>
sequence<T>::~sequence()
{
	if (array != NULL)
		delete [] array;
}


// overloads the [] operator to access sequence items
template <typename T>
T& sequence<T>::operator[] (int i)
{
	return array[i-1];
}


// a simple Swap method to swap the value of x and y
template <typename T>
void sequence<T>::swap(T& x, T& y)
{
	T temp=y;
	y=x;
	x=temp;
}


// Quicksort algorithm
template <typename T>
void sequence<T>::quicksort(T A[], int low, int high)
{
	T pivot;
	int scanup, scandown;
	int mid;
	if(high-low<=0)
		return;
	else
		if(high-low==1)
		{
			if(A[high]<A[low])
				swap(A[low], A[high]);
			return;
		}
	mid=(low+high)/2;
	pivot=A[mid];

	swap(A[mid], A[low]);
	scanup=low+1;
	scandown=high;

	do
	{
		while((!(scanup>scandown))&&(!(A[scanup]>pivot)))
			scanup++;
		while(pivot<A[scandown])
			scandown--;
		if(scanup<scandown)
		{
			swap(A[scanup],A[scandown]);
		}
	}
	while(scanup<scandown);

	A[low]=A[scandown];
	A[scandown]=pivot;

	if(low<scandown-1)
		quicksort(A, low, scandown-1);
	if(scandown+1<high)
		quicksort(A, scandown+1, high);
}

// sort the whole sequence using quicksort() method
template <typename T>
void sequence<T>::sort()
{
	quicksort(array, 0, seqSize-1);
}

// overloads << to output the whole sequence
template <typename T>
ostream& operator<< (ostream& ostr, sequence<T>& rhs)
{
	for(int i=0;i<rhs.seqSize;i++)
		ostr<<rhs.array[i]<<endl;
	return ostr;
}

#endif   // sequence_h